/*
 *  Copyright 2020-2024 Yuntu Microelectronics co.,ltd
 *  All rights reserved.
 * 
 *  YUNTU Confidential. This software is owned or controlled by YUNTU and may only be
 *  used strictly in accordance with the applicable license terms. By expressly
 *  accepting such terms or by downloading, installing, activating and/or otherwise
 *  using the software, you are agreeing that you have read, and that you agree to
 *  comply with and are bound by, such license terms. If you do not agree to be
 *  bound by the applicable license terms, then you may not retain, install,
 *  activate or otherwise use the software. The production use license in
 *  Section 2.3 is expressly granted for this software.
 * 
 * @file dma_config.c
 * @brief 
 * 
 */


#include <stddef.h>
#include "dma_config.h"

/*
PB0: Ԥ
PB1: 1 (̶ߵƽ)
PB2: Ԥ
PB3: 0 (̶͵ƽ)
PB4: Ԥ
PB5: Ԥ
*/
/*dma_config0*/
volatile uint32_t ioSentBuff[16] = {
    // һ PB0 = ߵƽPB1 = ߵƽPB2 = ߵƽPB3 = ͵ƽPB4 = ߵƽPB5 = ߵƽ
    0x00000037,  // PSOR: PB0, PB1, PB2, PB4, PB5ΪߵƽPB3Ϊ͵ƽ
    0x00000000,  // PCOR: 

    // ڶ PB0 = ͵ƽPB1 = ߵƽPB2 = ͵ƽPB3 = ͵ƽPB4 = ߵƽPB5 = ߵƽ
    0x00000000,  // PSOR: 
    0x00000005,  // PCOR: PB0, PB2, PB4, PB5Ϊ͵ƽPB3ֵ͵ƽPB1ָߵƽ

    //  PB0 = ߵƽPB1 = ߵƽPB2 = ߵƽPB3 = ͵ƽPB4 = ͵ƽPB5 = ͵ƽ
    0x00000005,  // PSOR: PB0, PB2Ϊߵƽ
    0x00000030,  // PCOR: PB4, PB5Ϊ͵ƽ

    //  
    0x00000030,  
    0x0000005,  

    // 
    0x0000005,  
    0x00000030,  

    // 
    0x000000030,  
    0x0000005,  

    // 
    0x00000005,  
    0x00000030,  

    // ڰ
    0x00000030,  
    0x00000005,  
};
/*test*/
volatile uint32_t test[16]={0}; //DMA

#define REG_ADDR_PSOR  0x4000f104
#define REG_ADDR_PCOR  0x4000f108
/* 
 * dma_config0DMAͨĽṹ
 * ýṹ嶨DMAͨòͨáԴ󡢻ص
 */
const dma_channel_config_t dma_config0 = {
    .virtChnConfig = 0,                          // ͨãΪ0ʾδ
    .source = DMA_REQ_DISABLED,                  // ԴãʾDMAͨκԴ
    .callback = NULL,                            // صΪNULLʾʹûص
    .callbackParam = NULL,                       // صΪNULL
};

/*
 * dmaChnConfigArrayDMAͨ
 * 洢DMAͨýṹָ롣ʾֻһDMAͨ
 */
const dma_channel_config_t *const dmaChnConfigArray[NUM_OF_CONFIGURED_DMA_CHANNEL] = {
    &dma_config0,  // õһDMAͨýṹ
};

/*
 * dmaController_InitConfigDMAʼ
 * ýṹڳʼDMAһЩȫãֹͣΪȡ
 */
const dma_user_config_t dmaController_InitConfig = {
    .haltOnError = false,  // DMAڷʱֹͣ
};

/*
 * dma_config0_StateDMAͨ0״̬ṹ
 * ýṹڴ洢DMAͨ0״̬ϢͨDMA׷ٺ͹
 */
dma_chn_state_t dma_config0_State;

/*
 * dmaChnStateDMAͨ״̬
 * 洢ÿDMAͨ״̬ṹָ롣ڴʾֻһDMAͨ
 */
dma_chn_state_t *const dmaChnState[NUM_OF_CONFIGURED_DMA_CHANNEL] = {
    &dma_config0_State,  // ָͨ0״̬ṹ
};

/*
 * dmaStateDMA״̬ṹ
 * ýṹڴ洢DMA״̬Ϣ
 */
dma_state_t dmaState;

/*
 * dma_transfer_config0LoopConfigDMAѭ
 * ýṹ嶨DMAѭòݴʱѭģʽ
 */
dma_loop_transfer_config_t dma_transfer_config0LoopConfig = {
    .triggerLoopIterationCount = 1,         // ѭĵΪ1
    .srcOffsetEnable = true,               // Դַƫ
    .dstOffsetEnable = false,               // Ŀַƫ
    .triggerLoopOffset = 0,                 // ѭƫΪ0
    .transferLoopChnLinkEnable = false,     // DMAͨ
    .transferLoopChnLinkNumber = 0,         // ûӵDMAͨ
    .triggerLoopChnLinkEnable = false,      // ôѭDMAͨ
    .triggerLoopChnLinkNumber = 0,          // ûӵDMAͨ
};

/*
 * dma_transfer_config0DMAýṹ
 * ýṹ嶨DMAԴַĿַСƫá
 * ζDMA`ioSentBuff`ԴַݵĿַ
 */
dma_transfer_config_t dma_transfer_config0 = {
    .srcAddr = (uint32_t)&ioSentBuff,         // ԴַָioSentBufftest
    .destAddr = REG_ADDR_PSOR,           // ʼĿַΪ0x4000f104
		//.destAddr = (uint32_t)&test,          
    .srcOffset = 8,                           // Դַÿƫ8ֽ
    .destOffset = 0,                          // Ŀַÿƫ0ֽڣ߼ʵֵַл
    .srcTransferSize = DMA_TRANSFER_SIZE_8B,  // ԴݴСΪ8ֽ
    .destTransferSize = DMA_TRANSFER_SIZE_8B, // ĿݴСΪ8ֽ
    .srcModulo = DMA_MODULO_OFF,              // ԴַĻλ
    .destModulo = DMA_MODULO_OFF,             // ĿַĻλ
    .transferLoopByteCount = 8, 							// ÿδ4ֽ
    .srcLastAddrAdjust = 0,                   // ԴַĵΪ0
    .destLastAddrAdjust = -8,                  // ĿַĵΪ-8
    .interruptEnable = true,                 // DMAж
    .loopTransferConfig = &dma_transfer_config0LoopConfig,  // ѭãʹ֮ǰѭ
};